var isIntegerRegExp = /^[+-]?[1-9]+[0-9]*$/;
function isInteger (int_val) {
    return isIntegerRegExp.test(int_val);
};

Titanium.UI.setBackgroundColor('#fff');

win = Ti.UI.currentWindow;

var db = Titanium.Database.install('test.sqlite', 'location');			

var search = Titanium.UI.createSearchBar({
   height:40,
   hintText:'Enter postcode or suburb',
   top:0
});
 
var table_data = [];
var autocomplete_table = Titanium.UI.createTableView({
   search: search,
   scrollable: true,
   top:0
});
win.add(autocomplete_table);

var last_search = null;
var autocompleteTimer = 0;

search.addEventListener('change', function(e)
{
   if (search.value.length > 1 && search.value !=  last_search)
   {
   		clearTimeout( autocompleteTimer );
   		autocompleteTimer = setTimeout(function()
   		{
			last_search = search.value;
			auto_complete( search.value );
   		}, 300);
   }
   return false;
});

function auto_complete(search_term)
{
   if (search_term.length > 1)
   {
		table_data = [];
		
		if ( isInteger(search_term) )
		{
			var rows = db.execute('SELECT * FROM location WHERE postcode LIKE \'%' + search_term + '%\' ORDER BY name LIMIT 20');
			Ti.API.debug('row count: ' + rows.rowCount);
			
			while (rows.isValidRow()) {
				var row = Ti.UI.createTableViewRow(
				{
					height: 40,
					title: rows.fieldByName('name'),
					hasDetail:true
				});
				
				table_data.push(row);			
			    rows.next();
			}						
		}
			
		else
		{
			var rows = db.execute('SELECT * FROM location WHERE name LIKE \'%' + search_term + '%\' ORDER BY name LIMIT 20');
			Ti.API.debug('row count: ' + rows.rowCount);
			
			while (rows.isValidRow()) {
				var row = Ti.UI.createTableViewRow(
				{
					height: 40,
					title: rows.fieldByName('name'),
					hasDetail:true
				});
				
				table_data.push(row);		
			    rows.next();
			}		
		}
		
		autocomplete_table.setData(table_data);
		rows.close();		         
   }
}